@use './common/constants' as *;
@use './common/mixins' as *;

@use './components/sidebar';
@use './components/header';

@import url('https://fonts.googleapis.com/css2?family=Roboto:wght@300;400;500;700&family=Work+Sans:ital,wght@0,300;0,400;0,500;0,700;0,900;1,300;1,400;1,500;1,700;1,900&display=swap');


// REPEATING ELEMENTS
* {
	box-sizing: border-box;
	-webkit-font-smoothing: antialiased;
	// Firefox scrollbar
	scrollbar-color: $scrollbar-color transparent;
	scrollbar-width: thin;

	&,
	&::before,
	&::after {
		box-sizing: inherit;
	}

	// Chrome, Edge, Safari scrollbar
	&::-webkit-scrollbar {
		height: $scrollbar-webkit-width;
		width: $scrollbar-webkit-width;

		&-thumb {
			background-color: $scrollbar-color;
			border-radius: $scrollbar-webkit-border-radius;
		}
	}
}

a {
	color: inherit;
	text-decoration: none;
	transition: color $transition;
}

// Inline Code
code {
	:not(pre) > & {
		background: map-get($pot-mauve, 7);
		border-radius: $border-radius;
		color: map-get($pot-grey, 1);
		font-family: Consolas, Monaco, 'Andale Mono', 'Ubuntu Mono', monospace;
		font-size: 1.4rem;
		padding: 2px 4px;
		word-break: break-word;
	}
}

em {
	word-break: break-word;
}

h1,
h2,
h3,
h4,
h5 {
	font-weight: 700;
	margin: 0 0 $buffer-s;

	// Offset so article's main headings aren't obscured by header when scrolling to them after clicking on links in TOC
	article > &::before {
		$buffer: header.$height + $buffer-s;
		content: '';
		display: block;
		height: $buffer;
		margin: -($buffer) 0 0;
		pointer-events: none;
	}
}

h1,
h2 {
	*:not(h1):not(h2) + & {
		margin-top: $buffer-xl;
	}
}

h3,
h4,
h5 {
	*:not(h1):not(h2):not(h3):not(h4):not(h5):not(h6) + & {
		margin-top: $buffer-m;
	}
}

h1 {
	font-size: 4.8rem;
	font-weight: 900;
	line-height: 1;
	margin-bottom: $buffer-m;
}

h2 {
	font-size: 4rem;
	font-weight: 700;
	line-height: 1.2;
}

h3 {
	font-size: 2.5rem;
	line-height: 1.4;
}

h4 {
	font-size: 1.8rem;
	line-height: 1.4;
}

hr {
	margin: $buffer-s 0;
}

kbd {
	background-color: map-get($pot-grey, 1);
	border: 1px solid map-get($pot-grey, 3);
	border-radius: 3px;
	font-family: inherit;
	font-size: 1.3rem;
	margin: 0 2px;
	padding: 2px 4px;
	white-space: nowrap;
}

ol {
	list-style-position: inside;
	padding: 0;
}

p {
	margin: 0 0 $buffer-s;
}

table {
	border-collapse: collapse;
}

tr,
td,
th {
	border: 1px solid map-get($pot-mauve, 7);
}

td,
th {
	min-width: 100px;
	padding: 10px;
}

ul {
	list-style-position: inside;
	margin: 0;
	padding: 0;
}

// ONE-OFF ELEMENTS
html {
	box-sizing: border-box;
	font-size: 10px;
	height: 100%;
}

body {
	font-family: 'Work Sans', sans-serif;
	font-size: 1.6rem;
	height: 100%;
	line-height: 1.5em;
	margin: 0;
}

main {
	height: 100%;

	@include mq(desktop) {
		display: grid;
		grid-template-columns: sidebar.$width minmax(0, 1fr);
	}
}

.toc {
	@include bordered($padding: 5px $buffer-xs);

	list-style: none;
	max-height: 140px;
	overflow-y: auto;

	[heading="h3"] {
		margin-left: $buffer-xs;
	}

	[heading="h4"] {
		padding-left: calc(2 * #{$buffer-xs});
	}

	[heading="h5"] {
		padding-left: calc(3 * #{$buffer-xs});
	}

	[heading="h6"] {
		padding-left: calc(4 * #{$buffer-xs});
	}
}
